SystemOrganization addCategory: #'OpenVolunteerMarketPlace-Model'!
SystemOrganization addCategory: #'OpenVolunteerMarketPlace-View'!
SystemOrganization addCategory: #'OpenVolunteerMarketPlace-Controller'!
SystemOrganization addCategory: #'OpenVolunteerMarketPlace-Tests'!

WAComponent subclass: #OVMPContentView
	instanceVariableNames: 'searchBox projectListView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-View'!

!OVMPContentView methodsFor: 'initialization' stamp: 'ThiagoFurtado 10/3/2012 12:16'!
initialize 
	super initialize .
	searchBox := OVMPSeachProjectView new.
	projectListView := OVMPProjectListView new.! !

!OVMPContentView methodsFor: 'rendering' stamp: 'ThiagoFurtado 10/3/2012 12:13'!
renderContentOn: html

	html section id: 'content';
		with: [
			html render: searchBox.
			html render: projectListView.
			].! !

WAComponent subclass: #OVMPLoginView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-View'!

!OVMPLoginView methodsFor: 'rendering' stamp: 'ThiagoFurtado 10/3/2012 09:01'!
renderContentOn: html

			html div
				id: 'login';
				with: [
					html form 
					id: 'formlogin';
					with: [
						html fieldSet
							class: 'up';
							with: [
								"html label for: 'email'; with: 'email/username'. "html textInput id: 'email'; type: 'text'; placeholder: 'user/email'.
								"html label for: 'pwd'; with: 'password'." html textInput id: 'pwd';type: 'password'; placeholder: 'password'.
								html submitButton id: 'enter'; class: 'btn'; with: 'Enter'.
								]
						 ].
			].! !

WAComponent subclass: #OVMPNewProjectView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-View'!

!OVMPNewProjectView methodsFor: 'project' stamp: 'ThiagoFurtado 10/3/2012 21:01'!
addProject
	self answer: true.! !

!OVMPNewProjectView methodsFor: 'project' stamp: 'ThiagoFurtado 10/3/2012 20:48'!
cancelAdding
	self answer: false.! !

!OVMPNewProjectView methodsFor: 'rendering' stamp: 'ThiagoFurtado 10/3/2012 15:25'!
renderContentOn: html

	html article
		id: 'projectadding';
		with: [self renderProjectForm: html.]
		
											! !

!OVMPNewProjectView methodsFor: 'rendering' stamp: 'ThiagoFurtado 10/4/2012 00:04'!
renderProjectForm: html

	html article
		id: 'adding';
		with: [ 			
					html form
						id: 'addform';
						with: [ 
									html fieldSet
										class: 'addclass';
										with: [ 
													html textInput
														id: 'projectname';
														type: 'text';
														placeholder: 'Enter a project name'.
													html textInput 
														id: 'projectURL';
														placeholder: 'Enter a URL'.
													html textArea 
														id: 'projectdescription';
														placeholder: 'Enter a description'.
														"rows: 5;
														columns: 100."
													html submitButton 
														id: 'cancelbtn';
														class: 'btn';
														on: #cancelAdding of: self;
														with: 'Cancel'.
													html submitButton 
														id: 'addbtn';
														class: 'btn';
														on: #addProject of: self; 
														with: 'Add'.
												]	
							]				
				]					! !

WAComponent subclass: #OVMPProjectListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-View'!

!OVMPProjectListView methodsFor: 'rendering' stamp: 'ThiagoFurtado 10/3/2012 13:01'!
renderContentOn: html
	| projects |
	
	"just to test"
	projects := Array new.
	
	html div id: 'list';
		with: [
			
			html unorderedList: [
					projects do: [ :project |
							html listItem: [ html render: project. ].
						]
				]			
			
			].! !

WAComponent subclass: #OVMPProjectView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-View'!

WAComponent subclass: #OVMPSeachProjectView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-View'!

!OVMPSeachProjectView methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/3/2012 14:48'!
addNewProject
	| newProjectView |
	newProjectView := OVMPNewProjectView new.
	
	self call: newProjectView.! !

!OVMPSeachProjectView methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/3/2012 14:38'!
addNewProject: aProject

	self call: (OVMPNewProjectView new yourself)! !

!OVMPSeachProjectView methodsFor: 'rendering' stamp: 'ThiagoFurtado 10/3/2012 21:28'!
renderContentOn: html
	html article
		id: 'projectmgmt';
		with: [self renderFields: html.]
		
											
	! !

!OVMPSeachProjectView methodsFor: 'rendering' stamp: 'ThiagoFurtado 10/3/2012 21:28'!
renderFields: html

	html article
		id: 'search';
		with: [ 			
					html form
						id: 'searchform';
						with: [ 
									html fieldSet
										class: 'searchclass';
										with: [ 
													html submitButton 
														id: 'addproject';
														class: 'btn';
														callback: [self addNewProject ];																
														with: 'New'.
													html textInput
														id: 'projectfield';
														type: 'text';
														placeholder: 'Enter the searching project name'.
													html submitButton
														id: 'enter';
														class: 'btn';
														with: 'Search' ] ] ]! !

WAComponent subclass: #OVMPView
	instanceVariableNames: 'loginComponent centerComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-View'!

!OVMPView class methodsFor: 'class initialization' stamp: 'ThiagoFurtado 9/22/2012 14:31'!
initialize

	WAAdmin register: self asApplicationAt: 'openvolunteermarketplace' .! !

!OVMPView methodsFor: 'accessing' stamp: 'ThiagoFurtado 9/29/2012 00:22'!
children 
	^ Array with: loginComponent with: searchProjectBox with: centerComponent.! !

!OVMPView methodsFor: 'initialization' stamp: 'ThiagoFurtado 10/3/2012 12:14'!
initialize 
	super initialize .
	loginComponent := OVMPLoginView new.
	centerComponent := OVMPContentView new.! !

!OVMPView methodsFor: 'rendering' stamp: 'ThiagoFurtado 10/3/2012 12:13'!
renderBodyContentOn: html

	html section id: 'content';
		with: [
			html render: centerComponent.
			].! !

!OVMPView methodsFor: 'rendering' stamp: 'ThiagoFurtado 9/28/2012 23:39'!
renderContentOn: html

	html div 
		id: 'main';
		with: [ self renderHeaderOn: html .
			    self renderBodyContentOn: html ].! !

!OVMPView methodsFor: 'rendering' stamp: 'ThiagoFurtado 10/3/2012 09:02'!
renderHeaderOn: html
	html header
		id: 'header';
		with: [ 
					html div
						id: 'in-header';
						with: [ 
									html heading
										level: 1;
										with: [ 
													html anchor
														url: 'http://localhost:8080/openvolunteermarketplace';
														with: 'Open Volunteer MarketPlace' ].
									self renderLoginForm: html ] ]! !

!OVMPView methodsFor: 'rendering' stamp: 'ThiagoFurtado 9/28/2012 23:48'!
renderLoginForm: html

	html render: loginComponent.! !

!OVMPView methodsFor: 'rendering' stamp: 'pbm 10/5/2012 14:31'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Open Volunteer Marketplace'.
	anHtmlRoot stylesheet url: 'http://localhost/openvolunteermarketplace/styles/style.css'! !

TestCase subclass: #DatabaseTestCase
	instanceVariableNames: 'database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Tests'!

!DatabaseTestCase methodsFor: 'as yet unclassified' stamp: 'pbm 10/20/2012 22:11'!
setUp
	database := Database new.! !

!DatabaseTestCase methodsFor: 'as yet unclassified' stamp: 'pbm 10/20/2012 22:11'!
testAddAndRemoveVolunteer
	|volunteer collection|
	volunteer :=  (OVMPVolunteer new name: 'name1'; email: 'email1@domain.com'; yourself).
	
	collection := database create: #volunteer.  
	
	database at: #volunteer add: volunteer.
	
	self should: [ (database collection: #volunteer  ) includes: volunteer. ].
	
	database at: #volunteer remove: volunteer.
	
	self shouldnt: [ (database collection: #volunteer) includes: volunteer. ].! !

!DatabaseTestCase methodsFor: 'as yet unclassified' stamp: 'pbm 10/20/2012 22:11'!
testFilterVolunteerByName
	|filter volunteer |
	database create: #volunteer.
	volunteer := OVMPVolunteer new name:'paulo'; email: 'paulo@domain.com'; yourself.
	database at: #volunteer add:(volunteer ).
	database at: #volunteer add:(OVMPVolunteer new name:'thiago'; email: 'thiago@domain.com'; yourself ).
	filter := database at: #volunteer filter: #name by: 'paulo'.
	self should: [filter size = 1].
	self should:[filter includes: volunteer ].! !

!DatabaseTestCase methodsFor: 'as yet unclassified' stamp: 'pbm 10/20/2012 22:12'!
testcreateCollection
	self should: [(database collection: #volunteer) isNil   ].
	database create: #volunteer.
	self shouldnt: [(database collection: #volunteer) isNil ].
! !

TestCase subclass: #InterfaceTestCase
	instanceVariableNames: 'ovmp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Tests'!

!InterfaceTestCase methodsFor: 'as yet unclassified' stamp: 'pbm 10/20/2012 22:19'!
setUp
	ovmp := OpenVolunteerMarketplace new.! !

!InterfaceTestCase methodsFor: 'adding' stamp: 'pbm 10/20/2012 22:35'!
testAddCoordinatorToProject
	|coordinator newcoordinator project|
	
	coordinator := ovmp newVolunteer: 'coordinator'.
	newcoordinator := ovmp newVolunteer: 'newcoordinator'.
	
	project := ovmp project: 'project001'.
	self should: [ project isNil  ].
	
	project := ovmp newProject: 'project001' coordinatedBy: coordinator .
	
	project := ovmp project: 'project001'.
	self shouldnt: [ project isNil  ].
	
	ovmp addCoordinator: newcoordinator for: project  withPermissionsOf: coordinator.
	
	self should: [ (ovmp project: 'project001') coordinators includes: coordinator ].
	self should: [ (ovmp project: 'project001') coordinators includes: newcoordinator ].
	
	! !

!InterfaceTestCase methodsFor: 'adding' stamp: 'pbm 10/20/2012 22:33'!
testAddNewProject
	|projectname user |
	
	projectname := 'project001'.
	self shouldnt: [ ovmp hasProject: projectname    ].
	
	user := ovmp newVolunteer: 'username'.
	ovmp newProject: projectname coordinatedBy: user.

	self should: [ ovmp hasProject: projectname   ].
	
! !

!InterfaceTestCase methodsFor: 'adding' stamp: 'pbm 10/20/2012 22:20'!
testAddNewSkill
	|user|
	
	user := ovmp volunteer: 'admin'.
	
	self should: [ (ovmp skill: 'skill') isNil ].
	
	ovmp newSkill: 'skill' withPermissionsOf: user.
	
	self shouldnt: [ (ovmp skill: 'skill') isNil ].
	
	ovmp removeSkill: (ovmp skill: 'skill') withPermissionsOf: user.! !

!InterfaceTestCase methodsFor: 'adding' stamp: 'pbm 10/20/2012 22:38'!
testAddNewVolunteer
	|username|
	
	username := 'testVolunteer'. 

	self shouldnt: [ ovmp hasVolunteer: username ].
	
	ovmp newVolunteer: username.
	
	self should: [ ovmp hasVolunteer: username ].
	
	
	
	! !

!InterfaceTestCase methodsFor: 'changing' stamp: 'pbm 10/20/2012 22:51'!
testCandidatingToTask
	|project task candidate|
	
	candidate := ovmp newVolunteer: 'user'.
	project := ovmp newProject: 'project'  coordinatedBy: candidate.
	task := ovmp newTaskFor: project.
	ovmp candidate: candidate  toTask: task .
	self should: [task candidates includes: candidate  ]. 
	! !

!InterfaceTestCase methodsFor: 'getting' stamp: 'pbm 10/20/2012 22:49'!
testGetProject
	|projectname user |
	
	projectname := 'project001'.
	self shouldnt: [ ovmp hasProject: projectname].
	
	user :=  ovmp newVolunteer: 'username'.
	ovmp newProject: projectname coordinatedBy: user.

	self should: [ ovmp hasProject: projectname].
	
	self should: [(ovmp project: 'project001') coordinators includes: user].
! !

!InterfaceTestCase methodsFor: 'getting' stamp: 'pbm 10/20/2012 22:42'!
testGetVolunteer
	|username|
	
	username := 'testVolunteer'. 

	self shouldnt: [ ovmp hasVolunteer: username ].
	
	ovmp newVolunteer: username.
	
	self should: [ ovmp hasVolunteer: username ].
	
	self should: [(ovmp volunteer: username) username = username].
	
	
	
	
	! !

Object subclass: #Database
	instanceVariableNames: 'Collections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Controller'!

!Database methodsFor: 'accessing collections' stamp: 'pbm 10/20/2012 22:07'!
at: aSymbol add: aValue
	^(self collection: aSymbol) add: aValue   ! !

!Database methodsFor: 'accessing collections' stamp: 'pbm 10/20/2012 22:07'!
at: aSymbol filter: anAttribute by: aValue
	|message collection|
	message := Message new setSelector: anAttribute arguments: #(); yourself .
	collection := self collection: aSymbol.
	^collection select: [:item | (message sendTo: item) = aValue].  
! !

!Database methodsFor: 'accessing collections' stamp: 'pbm 10/20/2012 22:08'!
at: aSymbol remove: aValue
	(self collection: aSymbol) remove: aValue   ! !

!Database methodsFor: 'accessing collections' stamp: 'pbm 10/20/2012 22:08'!
at: aSymbol removeAll: aCollection
	(self collection: aSymbol) removeAll: aCollection ! !

!Database methodsFor: 'accessing' stamp: 'pbm 10/20/2012 22:08'!
collection: aSymbol
	^Collections at: aSymbol ifAbsent: nil! !

!Database methodsFor: 'accessing' stamp: 'pbm 10/20/2012 22:09'!
create: aSymbol
	(Collections isNil ) ifTrue: [self initialize ].  
	Collections add: aSymbol -> (Set new).! !

!Database methodsFor: 'class initialization' stamp: 'pbm 10/20/2012 22:09'!
initialize 
	super initialize .
	Collections := Dictionary new.! !

Object subclass: #OVMPInvitation
	instanceVariableNames: 'task inviting invitee status comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Model'!

!OVMPInvitation class methodsFor: 'initialize-release' stamp: 'pbm 10/20/2012 20:24'!
to: aVolunteer for: aTask by: aCoordinator
	super new invitee: aVolunteer; task: aTask; inviting: aCoordinator
	! !

!OVMPInvitation methodsFor: 'accessing' stamp: 'pbm 10/20/2012 19:31'!
comment
	^comment ! !

!OVMPInvitation methodsFor: 'initialize-release' stamp: 'pbm 10/20/2012 20:25'!
initialize 
	status := #pending.! !

!OVMPInvitation methodsFor: 'accessing' stamp: 'pbm 10/20/2012 19:29'!
invitee 
	^invitee ! !

!OVMPInvitation methodsFor: 'accessing' stamp: 'pbm 10/20/2012 19:30'!
invitee: anInvitee
	invitee := anInvitee ! !

!OVMPInvitation methodsFor: 'accessing' stamp: 'pbm 10/20/2012 19:30'!
inviting
	^inviting
	! !

!OVMPInvitation methodsFor: 'accessing' stamp: 'pbm 10/20/2012 19:30'!
inviting: anInviting
	inviting := anInviting 
	! !

!OVMPInvitation methodsFor: 'accessing' stamp: 'pbm 10/20/2012 20:00'!
reject
	status := #rejected.
! !

!OVMPInvitation methodsFor: 'accessing' stamp: 'pbm 10/20/2012 19:33'!
reject: aComment
	status := #rejected.
	comment := aComment   ! !

!OVMPInvitation methodsFor: 'accessing' stamp: 'pbm 10/20/2012 19:29'!
status
	^status! !

!OVMPInvitation methodsFor: 'accessing' stamp: 'pbm 10/20/2012 19:30'!
task
	^task! !

!OVMPInvitation methodsFor: 'accessing' stamp: 'pbm 10/20/2012 19:31'!
task: aTask
	task := aTask ! !

Object subclass: #OVMPProject
	instanceVariableNames: 'name startDate endDate state tasks coordinators creator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Model'!

!OVMPProject class methodsFor: 'as yet unclassified' stamp: 'pbm 10/19/2012 20:48'!
forName: aName
	^self new name: aName; yourself! !

!OVMPProject methodsFor: 'updating' stamp: 'ThiagoFurtado 10/20/2012 20:06'!
addCoordinator: aVolunteer
	( coordinators isNil ) ifTrue: [self initialize ].
	coordinators add: aVolunteer ! !

!OVMPProject methodsFor: 'updating' stamp: 'ThiagoFurtado 9/26/2012 11:14'!
addTask: aTask
	tasks add: aTask.! !

!OVMPProject methodsFor: 'updating' stamp: 'ThiagoFurtado 9/26/2012 11:15'!
addTasks: aTaskArray
	tasks addAll: aTaskArray.! !

!OVMPProject methodsFor: 'accessing' stamp: 'pbm 10/14/2012 17:46'!
coordinators
	^ coordinators ! !

!OVMPProject methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 16:19'!
creator
	^ creator.! !

!OVMPProject methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 16:19'!
creator: aVolunteer
	creator := aVolunteer.! !

!OVMPProject methodsFor: 'accessing' stamp: 'pbm 10/14/2012 17:43'!
endDate
	^ endDate ! !

!OVMPProject methodsFor: 'updating' stamp: 'pbm 10/14/2012 17:43'!
endDate: aDate
	endDate := aDate! !

!OVMPProject methodsFor: 'initialize-release' stamp: 'pbm 10/14/2012 18:29'!
initialize
	coordinators := Set new.
	tasks := SortedCollection new sort:[:first :second | first startDate <= second startDate ]; yourself .! !

!OVMPProject methodsFor: 'accessing' stamp: 'ThiagoFurtado 9/26/2012 11:12'!
name
	^ name.! !

!OVMPProject methodsFor: 'updating' stamp: 'ThiagoFurtado 9/26/2012 11:12'!
name: aName
	name := aName.! !

!OVMPProject methodsFor: 'updating' stamp: 'pbm 10/14/2012 17:46'!
removeCoordinator: aCoordinator
	coordinators remove: aCoordinator   ! !

!OVMPProject methodsFor: 'accessing' stamp: 'ThiagoFurtado 9/26/2012 11:13'!
startDate
	^ startDate.! !

!OVMPProject methodsFor: 'updating' stamp: 'ThiagoFurtado 9/26/2012 11:12'!
startDate: aDate
	startDate := aDate.! !

!OVMPProject methodsFor: 'accessing' stamp: 'pbm 10/14/2012 17:44'!
state
	^ state! !

!OVMPProject methodsFor: 'updating' stamp: 'pbm 10/14/2012 17:44'!
state: aState
	state := aState ! !

!OVMPProject methodsFor: 'accessing' stamp: 'ThiagoFurtado 9/26/2012 11:13'!
tasks
	^ tasks.! !

Object subclass: #OVMPProjectController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Controller'!

!OVMPProjectController methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/3/2012 12:47'!
projects
	! !

Object subclass: #OVMPSkill
	instanceVariableNames: 'name description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Model'!

!OVMPSkill class methodsFor: 'as yet unclassified' stamp: 'ThiagoFurtado 10/20/2012 21:33'!
forName: aName
	^ self new name: aName; yourself .! !

!OVMPSkill methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 15:47'!
description
	^ description.! !

!OVMPSkill methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 15:47'!
description: aDescription
	description := aDescription.! !

!OVMPSkill methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 15:47'!
name
	^ name.! !

!OVMPSkill methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 15:47'!
name: aName
	name := aName.! !

Object subclass: #OVMPTask
	instanceVariableNames: 'name volunteers skills candidates startDate state estimatedDuration estimatedConclusionDate endDate project creator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Model'!

!OVMPTask class methodsFor: 'instance creation' stamp: 'pbm 10/14/2012 18:53'!
forProject: aProject startingAt: aDate
	aProject addTask: (self new startDate: aDate; yourself)! !

!OVMPTask methodsFor: 'updating' stamp: 'pbm 10/14/2012 18:03'!
addCandidate: aVolunteer
	candidates add: aVolunteer   ! !

!OVMPTask methodsFor: 'updating' stamp: 'pbm 10/14/2012 18:02'!
addSkill: aSkill
	skills add: aSkill     ! !

!OVMPTask methodsFor: 'updating' stamp: 'pbm 10/14/2012 17:59'!
addVolunteer: aVolunteer
	volunteers add: aVolunteer   ! !

!OVMPTask methodsFor: 'accessing' stamp: 'pbm 10/14/2012 17:58'!
candidates 
	^ candidates ! !

!OVMPTask methodsFor: 'testing' stamp: 'pbm 10/20/2012 18:39'!
checkCoveredSkills: aCollection
	"returns the skills from aCollection that are required by this task"
	^aCollection select: [:item| skills includes: item ].! !

!OVMPTask methodsFor: 'testing' stamp: 'pbm 10/20/2012 18:38'!
checkUncoveredSkills: aCollection
	"returns the skills not included in aCollection"
	^skills reject: [:item| aCollection includes: item  ].! !

!OVMPTask methodsFor: 'testing' stamp: 'pbm 10/20/2012 18:16'!
hasVolunteer
	^volunteers isEmpty not! !

!OVMPTask methodsFor: 'initialize-release' stamp: 'pbm 10/14/2012 18:16'!
initialize 
	volunteers := Set new.
	candidates := Set new.
	skills := Set new.! !

!OVMPTask methodsFor: 'updating' stamp: 'pbm 10/20/2012 20:31'!
isOpen
	^(state class = OVMPTaskOpened )! !

!OVMPTask methodsFor: 'accessing' stamp: 'pbm 10/14/2012 17:56'!
name
	^ name! !

!OVMPTask methodsFor: 'updating' stamp: 'pbm 10/14/2012 17:49'!
name: aName
	name := aName! !

!OVMPTask methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 12:20'!
project
	^ project.! !

!OVMPTask methodsFor: 'accessing' stamp: 'ThiagoFurtado 10/20/2012 12:20'!
project: aProject
	project := aProject .! !

!OVMPTask methodsFor: 'updating' stamp: 'pbm 10/14/2012 18:05'!
removeCandidate: aVolunteer
	candidates remove: aVolunteer ! !

!OVMPTask methodsFor: 'updating' stamp: 'pbm 10/14/2012 18:02'!
removeSkill: aSkill
	skills remove: aSkill   ! !

!OVMPTask methodsFor: 'updating' stamp: 'pbm 10/14/2012 18:00'!
removeVolunteer: aVolunteer
	volunteers remove: aVolunteer   ! !

!OVMPTask methodsFor: 'testing' stamp: 'pbm 10/14/2012 21:44'!
requiresSkill: aSkill
	^skills includes: aSkill     ! !

!OVMPTask methodsFor: 'accessing' stamp: 'pbm 10/14/2012 18:01'!
skills
	^ skills ! !

!OVMPTask methodsFor: 'accessing' stamp: 'pbm 10/14/2012 18:33'!
startDate
	^ startDate ! !

!OVMPTask methodsFor: 'updating' stamp: 'pbm 10/14/2012 18:34'!
startDate: aDate
	startDate := aDate ! !

!OVMPTask methodsFor: 'accessing' stamp: 'pbm 10/14/2012 17:57'!
volunteers
	^ volunteers ! !

Object subclass: #OVMPTaskState
	instanceVariableNames: 'task internalState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Model'!

OVMPTaskState subclass: #OVMPTaskCanceled
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Model'!

!OVMPTaskCanceled methodsFor: 'as yet unclassified' stamp: 'pbm 10/20/2012 18:11'!
open
	OVMPTaskOpened forTask: task.  ! !

OVMPTaskState subclass: #OVMPTaskFinished
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Model'!

OVMPTaskState subclass: #OVMPTaskOpened
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Model'!

!OVMPTaskOpened methodsFor: 'as yet unclassified' stamp: 'pbm 10/20/2012 18:12'!
postpone
	OVMPTaskPostponed forTask: task  ! !

!OVMPTaskOpened methodsFor: 'as yet unclassified' stamp: 'pbm 10/20/2012 18:18'!
run
	self canRun.
	OVMPTaskRunning forTask: task.! !

OVMPTaskState subclass: #OVMPTaskPostponed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Model'!

!OVMPTaskPostponed methodsFor: 'as yet unclassified' stamp: 'pbm 10/20/2012 18:13'!
open
	OVMPTaskOpened forTask: task.  ! !

!OVMPTaskPostponed methodsFor: 'as yet unclassified' stamp: 'pbm 10/20/2012 18:18'!
run
	self canRun.
	OVMPTaskRunning forTask: task.  ! !

OVMPTaskState subclass: #OVMPTaskRunning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Model'!

!OVMPTaskRunning methodsFor: 'as yet unclassified' stamp: 'pbm 10/20/2012 18:10'!
finish
	OVMPTaskFinished forTask: task.  ! !

!OVMPTaskState class methodsFor: 'as yet unclassified' stamp: 'pbm 10/20/2012 18:05'!
forTask: aTask
	aTask state: self new.! !

!OVMPTaskState methodsFor: 'as yet unclassified' stamp: 'pbm 10/20/2012 18:18'!
canRun
	task hasVolunteer ifFalse: [self error: 'cannot start a task without volunteers'].! !

!OVMPTaskState methodsFor: 'as yet unclassified' stamp: 'pbm 10/20/2012 18:07'!
cancel
	OVMPTaskCanceled forTask: task.  ! !

!OVMPTaskState methodsFor: 'as yet unclassified' stamp: 'pbm 10/20/2012 17:58'!
finish
	self subclassResponsibility ! !

!OVMPTaskState methodsFor: 'as yet unclassified' stamp: 'pbm 10/20/2012 17:57'!
open
	self subclassResponsibility ! !

!OVMPTaskState methodsFor: 'as yet unclassified' stamp: 'pbm 10/20/2012 17:58'!
postpone
	self subclassResponsibility ! !

!OVMPTaskState methodsFor: 'as yet unclassified' stamp: 'pbm 10/20/2012 17:57'!
run
	self subclassResponsibility ! !

Object subclass: #OVMPVolunteer
	instanceVariableNames: 'username password email name birthday skills admin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Model'!

!OVMPVolunteer class methodsFor: 'instance creation' stamp: 'pbm 10/19/2012 20:33'!
forUsername: aUsername
	^self new username: aUsername; yourself.! !

!OVMPVolunteer methodsFor: 'updating' stamp: 'ThiagoFurtado 9/26/2012 13:11'!
addSkill: aSkill
	skills add: aSkill.! !

!OVMPVolunteer methodsFor: 'updating' stamp: 'ThiagoFurtado 9/26/2012 13:12'!
addSkills: aSkillArray
	 skills addAll: aSkillArray.! !

!OVMPVolunteer methodsFor: 'initialize-release' stamp: 'ThiagoFurtado 10/20/2012 13:46'!
admin: aBoolean
	admin := aBoolean.! !

!OVMPVolunteer methodsFor: 'accessing' stamp: 'pbm 10/14/2012 19:12'!
email 
	^email ! !

!OVMPVolunteer methodsFor: 'updating' stamp: 'pbm 10/14/2012 19:13'!
email: anEmail
 email := anEmail ! !

!OVMPVolunteer methodsFor: 'testing' stamp: 'pbm 10/14/2012 21:45'!
hasSkill: aSkill
	^ skills includes: aSkill   ! !

!OVMPVolunteer methodsFor: 'initialize-release' stamp: 'pbm 10/20/2012 19:36'!
initialize 
	skills := Set new.
! !

!OVMPVolunteer methodsFor: 'initialize-release' stamp: 'ThiagoFurtado 10/20/2012 13:46'!
isAdmin
	^ admin.! !

!OVMPVolunteer methodsFor: 'accessing' stamp: 'pbm 10/14/2012 17:28'!
name
	"get person's name"
	^ name.! !

!OVMPVolunteer methodsFor: 'updating' stamp: 'pbm 10/14/2012 17:28'!
name: aName
	"set person's name"
	name := aName.! !

!OVMPVolunteer methodsFor: 'accessing' stamp: 'pbm 10/14/2012 19:11'!
password 
	^ password ! !

!OVMPVolunteer methodsFor: 'updating' stamp: 'pbm 10/14/2012 19:12'!
password: aPassword
	password := aPassword ! !

!OVMPVolunteer methodsFor: 'updating' stamp: 'pbm 10/14/2012 19:13'!
removeSkill: aSkill
	skills remove: aSkill     ! !

!OVMPVolunteer methodsFor: 'accessing' stamp: 'ThiagoFurtado 9/26/2012 13:11'!
skills
	^ skills.! !

!OVMPVolunteer methodsFor: 'accessing' stamp: 'pbm 10/14/2012 19:11'!
username
	^ username ! !

!OVMPVolunteer methodsFor: 'updating' stamp: 'pbm 10/14/2012 17:29'!
username: aUsername
	"set person's username"

	username := aUsername.! !

Object subclass: #OpenVolunteerMarketplace
	instanceVariableNames: 'database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenVolunteerMarketPlace-Controller'!

!OpenVolunteerMarketplace methodsFor: 'accessing' stamp: 'pbm 10/20/2012 22:15'!
accept: anInvitation by: anInvitee
	(anInvitation invitee = anInvitation) ifFalse: [self error:'operation not allowed'].
	anInvitation task addVolunteer: anInvitee.
	database at: #invitation remove: anInvitation .  
	! !

!OpenVolunteerMarketplace methodsFor: 'changing' stamp: 'pbm 10/20/2012 19:40'!
accept: aVolunteer toTask: aTask by: aCoordinator
	(aTask project coordinators includes: aCoordinator)  ifFalse: [self error:'operation not allowed'].  
	aTask addVolunteer: aVolunteer.  ! !

!OpenVolunteerMarketplace methodsFor: 'adding' stamp: 'ThiagoFurtado 10/20/2012 21:02'!
addCoordinator: newCoordinator for: aProject withPermissionsOf: aCoordinator
	|coordinator tmpProject|
	
	tmpProject := self project: ( aProject name ) .
	
	( tmpProject isNil )
		ifTrue: [
			self error: 'There is no project with name ', ( aProject name ). 
			]	
		ifFalse: [
			( (self project: ( aProject name )) coordinators  includes: aCoordinator)
			ifTrue: [	 (self project: ( aProject name )) addCoordinator: newCoordinator .]
			ifFalse: [self error: 'You have no permissions to assign another coordinator.']
			]
! !

!OpenVolunteerMarketplace methodsFor: 'initialize-release' stamp: 'pbm 10/20/2012 22:23'!
addFirstAdmin 
	database at: #volunteer add: (OVMPVolunteer new username: 'admin'; password: 'admin'; admin: true; name: 'Administrator').! !

!OpenVolunteerMarketplace methodsFor: 'changing' stamp: 'pbm 10/20/2012 17:23'!
candidate: aVolunteer toTask: aTask
	aTask addCandidate: aVolunteer.  ! !

!OpenVolunteerMarketplace methodsFor: 'testing' stamp: 'pbm 10/20/2012 22:15'!
existsUserIdentifiedBy: anUsername
	 (database at: #volunteer filter: #username by: anUsername ) isEmpty 
		ifTrue: [ ^ false. ] ifFalse: [^ true].! !

!OpenVolunteerMarketplace methodsFor: 'testing' stamp: 'pbm 10/20/2012 22:30'!
hasProject: aName
	^(database at: #project filter: #name by: aName) isEmpty not.! !

!OpenVolunteerMarketplace methodsFor: 'testing' stamp: 'pbm 10/20/2012 22:46'!
hasVolunteer: aUsername
	^(database at: #volunteer filter: #username by: aUsername) isEmpty not! !

!OpenVolunteerMarketplace methodsFor: 'initialize-release' stamp: 'pbm 10/20/2012 22:24'!
initialize 
	database := Database new.
	database create: #volunteer.
	database create: #project.
	database create: #task.
	database create: #skill.
	database create: #invitation.
	self addFirstAdmin.! !

!OpenVolunteerMarketplace methodsFor: 'accessing' stamp: 'pbm 10/20/2012 22:15'!
invitationsTo: aVolunteer
	^database at: #invitation filter: #invitee by: aVolunteer ! !

!OpenVolunteerMarketplace methodsFor: 'creating' stamp: 'pbm 10/20/2012 22:16'!
invite: aVolunteer to: aTask by: aCoordinator
	(aTask project coordinators includes: aCoordinator) ifFalse: [self error: 'operation not allowed'].
	database at: #invitation add: (OVMPInvitation to: aVolunteer  for: aTask  by: aCoordinator).
! !

!OpenVolunteerMarketplace methodsFor: 'creating' stamp: 'pbm 10/20/2012 22:48'!
newProject: aName coordinatedBy: aCoordinator
	|project|
	(self hasProject: aName)  
		ifFalse: [
			project := OVMPProject forName: aName.
			project addCoordinator: aCoordinator.  
			database at: #project add: project ]
		ifTrue:   [
			self error: 'project alreary exists'].
	^project ! !

!OpenVolunteerMarketplace methodsFor: 'creating' stamp: 'pbm 10/20/2012 22:16'!
newRequiredSkill: skill for: aTask addBy: aCoordinator 
	|tmpTask|
	tmpTask := (database at: #task filter: #name by: ( aTask name  ) ).
	( tmpTask isEmpty ) 
		ifTrue: [
			self error: 'There is no task named ', aTask name.] 
		ifFalse: [
			(( tmpTask project coordinators ) includes: aCoordinator ) ifTrue: [
			( database at: #task filter: #name by: (aTask name) ) addSkill: skill ]
			ifFalse: [ self error: aCoordinator , ' have no permissions to add skills.'] ] ! !

!OpenVolunteerMarketplace methodsFor: 'creating' stamp: 'pbm 10/20/2012 22:16'!
newSkill: aSkillName withPermissionsOf: aVolunteer
	"Only admin can pass this message"
	|skill|
	(aVolunteer isAdmin ) ifTrue: [
		
		((self skill: aSkillName) isNil )
		ifFalse: [
				self error: 'skill name aready exists.'] 
		ifTrue: [
				skill := OVMPSkill forName: aSkillName.
				database at: #skill add: skill].
		^skill   
		
		] ifFalse: [self error: 'You have no permission to modify skills'] .
	! !

!OpenVolunteerMarketplace methodsFor: 'creating' stamp: 'pbm 10/20/2012 22:16'!
newTaskFor: aProject
	|task|
	task := OVMPTask new.
	aProject addTask: task.
	^database at: #task add: task.  ! !

!OpenVolunteerMarketplace methodsFor: 'creating' stamp: 'pbm 10/20/2012 22:48'!
newVolunteer: aUsername
	|volunteer|
	 (self hasVolunteer: aUsername )  
		ifTrue: [
				self error:'username aready in use:', aUsername ] 
		ifFalse: [
				volunteer := OVMPVolunteer forUsername: aUsername.
				database at: #volunteer add: volunteer].
	^volunteer    ! !

!OpenVolunteerMarketplace methodsFor: 'accessing' stamp: 'pbm 10/20/2012 22:16'!
project: aName
	|project|
	project := (database at: #project filter: #name by: aName).
	
	( project isEmpty ) 
		ifTrue: [ ^nil ]
		ifFalse: [ project select: [:item | (item name = aName) ifTrue: [ ^ item ] ] ] 
		! !

!OpenVolunteerMarketplace methodsFor: 'accessing' stamp: 'pbm 10/20/2012 19:59'!
reject: anInvitation by: anInvitee
	(anInvitation invitee = anInvitation) ifFalse: [self error:'operation not allowed'].
	anInvitation reject.
	! !

!OpenVolunteerMarketplace methodsFor: 'accessing' stamp: 'pbm 10/20/2012 20:00'!
reject: anInvitation reason: aComment by: anInvitee
	(anInvitation invitee = anInvitation) ifFalse: [self error:'operation not allowed'].
	anInvitation reject: aComment.
	! !

!OpenVolunteerMarketplace methodsFor: 'removing' stamp: 'pbm 10/20/2012 22:17'!
removeInvitationsFor: aTask
		database at: #invitation removeAll: (database at: #invitation filter: #task by: aTask)
! !

!OpenVolunteerMarketplace methodsFor: 'removing' stamp: 'pbm 10/20/2012 22:17'!
removeProject: aProject withPermissionsOf: aVolunteer
	( aVolunteer isAdmin )
		ifTrue: [database at: #project remove: aProject ]
		ifFalse: [
			"Any creator can remove a project."
			( aProject creator = aVolunteer )
				ifTrue: [
					database at: #project remove: aProject ].
			]! !

!OpenVolunteerMarketplace methodsFor: 'removing' stamp: 'pbm 10/20/2012 22:17'!
removeProjectNamed: aName withPermissionsOf: aVolunteer
	|project|
	project := self project: aName.
	( aVolunteer isAdmin )
		ifTrue: [database at: #project remove: project ]
		ifFalse: [
			"Any creator can remove a project."
			( project creator = aVolunteer )
				ifTrue: [
					database at: #project remove: project ].
			]! !

!OpenVolunteerMarketplace methodsFor: 'removing' stamp: 'pbm 10/20/2012 22:17'!
removeSkill: aName withPermissionsOf: aVolunteer
	(aVolunteer isAdmin ) ifTrue: [database at: #skill remove: aName. ] ifFalse: ['You have no permission to modify skills'].! !

!OpenVolunteerMarketplace methodsFor: 'removing' stamp: 'ThiagoFurtado 10/20/2012 21:00'!
removeSkillNamed: aName withPermissionsOf: aVolunteer
	self removeSkill: (self skill: aName) withPermissionOf: aVolunteer.! !

!OpenVolunteerMarketplace methodsFor: 'removing' stamp: 'pbm 10/20/2012 22:17'!
removeTasks: aCollection
	aCollection do:[:task | self removeInvitationsFor: task].
		database at: #task removeAll: aCollection.! !

!OpenVolunteerMarketplace methodsFor: 'removing' stamp: 'pbm 10/20/2012 22:17'!
removeVolunteer: aVolunteer withPermissionsOf: me
	"only me or admin can remove from application"
	(aVolunteer = me) 
		ifTrue: [
			database at: #volunteer remove: aVolunteer. ]
		ifFalse: [
			(me isAdmin) 
				ifTrue: [ 
					database at: #volunteer remove: aVolunteer. ] 
				ifFalse: 
					[ self error: 'You can only remove yourself' ] ]! !

!OpenVolunteerMarketplace methodsFor: 'removing' stamp: 'pbm 10/20/2012 22:18'!
removeVolunteerNamed: aName withPermissionsOf: aVolunteer
	"only me or admin can remove from application"
	|volunteer|
	volunteer := self volunteer: aName.
	(volunteer = aVolunteer) 
		ifTrue: [
			database at: #volunteer remove: volunteer. ]
		ifFalse: [
			(aVolunteer isAdmin) 
				ifTrue: [ 
					database at: #volunteer remove: volunteer. ] 
				ifFalse: 
					[ self error: 'You can only remove yourself' ] ]! !

!OpenVolunteerMarketplace methodsFor: 'accessing' stamp: 'pbm 10/20/2012 22:18'!
skill: aName
	|skill|
	skill := (database at: #skill filter: #name by: aName).
	( skill isEmpty ) 
		ifTrue: [ ^nil ]
		ifFalse: [ skill select: [:item | (item name = aName) ifTrue: [ ^ item ] ] ] 
		! !

!OpenVolunteerMarketplace methodsFor: 'accessing' stamp: 'pbm 10/20/2012 22:18'!
suggestedTasks: aVolunteer
	"suggests the open tasks that require only known skills"
	^(database at: #task filter: #isOpen by: true) select: [:task| (task checkUncoveredSkills: aVolunteer skills) isEmpty ]  ! !

!OpenVolunteerMarketplace methodsFor: 'accessing' stamp: 'pbm 10/20/2012 22:18'!
suggestedVolunteers: aTask
	"suggests the volunteers who have all the required skills for aTask"
	^(database collection: #volunteer)  select: [:volunteer | (aTask checkUncoveredSkills: volunteer skills) isEmpty ].! !

!OpenVolunteerMarketplace methodsFor: 'accessing' stamp: 'pbm 10/20/2012 22:18'!
task: aName
	|task|
	task := (database at: #task filter: #name by: aName).
	( task isEmpty ) 
		ifTrue: [ ^nil ]
		ifFalse: [ task select: [:item | (item name = aName) ifTrue: [ ^ item ] ] ] 
		! !

!OpenVolunteerMarketplace methodsFor: 'accessing' stamp: 'pbm 10/20/2012 22:18'!
volunteer: anUsername
	|users|
	users := (database at: #volunteer filter: #username by: anUsername).
	
	( users isEmpty ) ifTrue: [ ^ nil ]
		ifFalse: [ users select: [:item | (item username = anUsername) ifTrue: [ ^ item ] ]  ]
		
	
	! !
OVMPView initialize!
